package sat;
import java.util.*;
import java.io.*;
import java.net.*;

// Copyright (c) 2002 Rick Mugridge, University of Auckland.
// Released under the terms of the GNU General Public License version 2 or later.

public class ClientSocket {
    protected String clientName;
    protected Socket socket;
    protected BufferedReader in;
    protected PrintWriter out;

    public ClientSocket(String host, int portNo, 
			String clientName) throws IOException {
	this(host,portNo,clientName,50);
    }
    public ClientSocket(String host, int portNo, 
			String clientName, int timeout) throws IOException {
	this.clientName = clientName;
	socket = new Socket(host,portNo);
	socket.setSoTimeout(timeout);
	in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	out = new PrintWriter(socket.getOutputStream(),true);
    }
    public void send(String msg) throws IOException {
	out.println(msg);
    }
    public String receive() throws IOException {
	return in.readLine();
    }
    public void close() throws IOException {
	socket.close();
    }
}
