package sat.fit;
import sat.*;
import fit.*;
import org.w3c.dom.*;

// Copyright (c) 2002 Rick Mugridge, University of Auckland.
// Released under the terms of the GNU General Public License version 2 or later.

    /** A fixture for running sats (Socket Acceptance Tests)
	with xml messages.
	The XML has to be pre-processed to unescape special characters
	and turn them into "<", etc.
	@author rick mugridge, october 2002
    */
public class SatXmlFixture extends SatFixture {
    protected final int tracingLevel = 0;

        /** Returns the string with all escaped characters that
	    are not handled by fit being unescaped.
	    Eg, "&quot" -> "\"" and "&amp" -> "&".
	*/
    protected String preProcessMsg(String msg) throws Exception {
	int ampersand = -1;
	while (true) {
	    ampersand = msg.indexOf("&",ampersand);
	    if (ampersand < 0)
		break;
	    int semicolon = msg.indexOf(";",ampersand+1);
	    if (semicolon < 0)
		break;
	    String escaped = msg.substring(ampersand+1,semicolon);
	    if (escaped.equals("quot"))
		msg = msg.substring(0,ampersand)+ "\"" + msg.substring(semicolon+1);
	    else if (escaped.equals("amp"))
		msg = msg.substring(0,ampersand)+ "&" + msg.substring(semicolon+1);
	}
	if (tracingLevel > 0)
	    System.out.println("Escaped msg in preprocess = '"+msg+"'");
	Element node = ProcessXML.getDoc(msg);
	if (tracingLevel > 0)
	    System.out.println("Element = "+node);
	return ProcessXML.getNodeAsString(node);
    }
    protected boolean equalMessages(String expected, String actual) {
	if (tracingLevel > 0)
	    System.out.println("equalMessages: '"+expected+"','"+actual+"'");
	if (expected.equals(actual))
	    return true;
	return ProcessXML.same(expected,actual);
    }
}
