package sat.mockServer;
import sat.*;
import java.io.*;
import java.net.*;

// Copyright (c) 2002 Rick Mugridge, University of Auckland.
// Released under the terms of the GNU General Public License version 2 or later.

   /** A server that receives "Hello", sends back "Hi" and then expects
       a ShutDown.
       @author rick mugridge, october 2002
   */
public class ServerHelloHi extends AbstractServer {
    public ServerHelloHi() {
	this(1234);
    }
    public ServerHelloHi(int portNo) {
	super(portNo);
    }
    public void manageConnections(ServerSocket server) throws IOException {
	new ServerThread(server.accept(),"Thread1") {
	    protected void check(BufferedReader in, 
				 PrintStream out) throws IOException {
		if (expectedMessage("<Hello/>"))
		    out.println("<Hi/>");
		expectShutdown();
	    }
	};
    }
}
